


#include <cerrno>
#include <stdio.h>
#include <list>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
#include <iostream>

#include <fstream>
#include "timer.h"
#include "incop.h"
#include "incoputil.h"
#include "csproblem.h"
#include "color.h"


#include <math.h>
#include <unistd.h>


extern ofstream* ofile;  // le fichier de sortie

extern Stat_GWW * Statistiques; 






void arguments_coloriage(char** argv, int& narg, int & nbcol)
{ 
  nbcol = argument2ul(argv[narg+1],"nombre de couleurs ");
  *ofile << " coloriage  " << argv[narg+1] << "  nb couleurs " << nbcol << endl;
  narg++;
}


int main (int argc, char** argv) {

  // les divers arguments lus dans la ligne de commande

  int nbcol,taille,nbessais;
  int graine1;

  int narg = 2;  // compteur des arguments 
  // le nom du fichier de sortie en 1er argument : pour les tests  arg ->  version logiciel + concatnation des arguments
  char filename [1000];
  if ((string)argv[1] == "arg")
    ofile_name(filename, argc, argv);
  else sprintf(filename,"%s",argv[1]);
      
  ofstream ofile1 (filename);
  ofile = & ofile1;

  ifstream file (argv[2]); // le fichier de donnes 

  // lecture des arguments du problme
  arguments_coloriage(argv,narg,nbcol);

  // lecture des paramtres de l'algo et cration de l'objet algo
  IncompleteAlgorithm* algo = algo_creation (argv, narg, taille, graine1, nbessais);

  // allocation de l'objet pour les stats
  Statistiques=new Stat_GWW (1, nbessais);
  
  // argument pour la trace
  arguments_tracemode(argv,narg);
  // pour la rcupration du signal 10
  sigaction();

  // creation du probleme (lecture des donnes, cration des structures de donnes et du problme)
  ColorCSProblem* problem = color_problem_creation (nbcol,file);

  // creation de la population et initialisation 
  // La population : tableau de configurations
  Configuration* population[taille];
  problem->init_population(population,taille);
  problem->allocate_moves();

  // initialisation des statistiques
  Statistiques->init_pb(0);

  // boucle sur les essais 

  for(int nessai = 0;nessai< nbessais ; nessai++)
    executer_essai (problem,algo,population,taille,graine1,nessai);

  // ecriture statistiques 
  Statistiques->current_try++; 
  ecriture_stat_probleme();
  delete problem;
  cout << "Fin rsolution " << Statistiques->total_execution_time << endl;
  return 0;
  
  
}



