


/* ------------------------------------------------------------
Les fonctions utilitaires de incop : lecture des arguments des algos , ecriture,  lancement d'un essai, 
------------------------------------------------------------ */



#include <cerrno>
#include <stdio.h>
#include <list>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
#include <iostream>
#include <fstream.h>
#include "timer.h"
#include "incop.h"
#include "incoputil.h"



#include <math.h>
#include <unistd.h>

#include <stdlib.h> 
#include <signal.h> 

ofstream* ofile;  // le fichier de sortie

Stat_GWW * Statistiques; //  l'objet pour les stats en var globale pour les signaux
                         // allou dans le main() avec npb et nbessais





int TRACEMODE=0;

struct sigaction Action;  // trombe_ajout : pour les signaux


/* ------------------------------------ STATISTIQUES ---------------------------------------*/

Stat_GWW::Stat_GWW (int number_problems, int number_tries) {
  nb_pbs=number_problems;
  trouve=new int[number_problems]; 
  for (int i=0 ; i < number_problems ; i++) { trouve[i]=0; } 
  max_tries=number_tries;
  cost_try=new int[number_tries];  
  execution_time_try=new float[number_tries]; 
  total_execution_time=0.0;
}

void Stat_GWW::init_pb(int t)
{current_pb = t; 
 thresholdchanges=0;
}

void Stat_GWW::execution_report(int nessai, int lower_bound)
{execution_time_try [nessai] += VIRTUAL_TIMELAPSE; 
    if (cost_try[nessai]== lower_bound) 
      { trouve[current_pb]++;}
    ecriture_stat_essai();
    total_execution_time += (float)execution_time_try[nessai];	  
}

void sigaction()
  {Action.sa_handler=handler_stat;           // trombe_ajout : dtournement du signal SIGUSR1
  sigaction(SIGUSR1, &Action, NULL);        // trombe_ajout : dtournement du signal SIGUSR1
  }


// ajout_trombe : rajout de la fonction suivante pour les signaux !!!

void handler_stat (int sig) {

  *ofile  << "==========================================================================" << endl;
  *ofile  << "Signal " << sig << " recu !!" << endl;

  ecriture_stat_probleme();   // stats sur les derniers essais du problme courant

  if (Statistiques->current_pb > 1) {
    ecriture_statistiques_global (); // stats sur tous les problmes
  }

  cout << "Fin resolution (interrompue) en : " << Statistiques->total_execution_time 
       << " secondes" << endl;

  sleep(1);

  kill (getpid(), 9);   // suicide

}



/*----------------------------------- LECTURE DES ARGUMENTS ----------------------------------*/

/* les fonctions de lecture et de vrification de type et de valeur des donnes */

int argument2ul(char* arg, char* message)
{char* error;
    int s = strtoul(arg,&error,10);
 if (error==arg  || errno==ERANGE)
   {cerr << "Erreur " << message << " pas un entier " <<  arg << endl;
   exit(1);
   }
 return s;
}


double argument2d(char* arg, char* message)
{char* error;
  errno=0; 
    double s = strtod (arg,&error);
 if (errno==ERANGE  || error == arg)
   {cerr << "Erreur " << message << " pas un nombre " <<  arg << endl;
   exit(1);
   }
 return s;
}

double argument2bd(char* arg, char* message, double min1, double max1)
{double s= argument2d(arg,message);
if (( s< min1) || (s > max1) )
  {cerr << "Erreur " << message << arg << " doit tre compris entre " << min1 << " et " << max1;
  exit(1);
  }
return s;
} 

int argument2bul(char* arg, char* message, int min1, int max1)
{int s= argument2ul(arg,message);
if (( s< min1) || (s > max1) )
  {cerr << "Erreur " << message << arg << " doit tre compris entre " << min1 << " et " << max1;
  exit(1);
  }
return s;
} 



string argument2lp(char* arg, char* message, list<string>& possibles)
{string s = arg;
 if (find(possibles.begin(),possibles.end(),arg)== possibles.end()) 
   {cerr << message << arg << endl; exit(1);}
return s;
}

/* la liste des mthodes implantes */

void definir_liste_methodes(list<string>& liste_methodes)
{liste_methodes.push_back("metropolis");
liste_methodes.push_back("tabu");
liste_methodes.push_back("simann");
liste_methodes.push_back("taburate");
liste_methodes.push_back("descente");
 liste_methodes.push_back("greedy");  // anglicisation de descente (meme methode)
liste_methodes.push_back("threshold");
liste_methodes.push_back("random");
liste_methodes.push_back("gww");
liste_methodes.push_back("gww-nothreshold"); 
liste_methodes.push_back("gww-killworst");
liste_methodes.push_back("gww-adaptkillworst");
liste_methodes.push_back("gww-mediandist");
liste_methodes.push_back("gww-bestdist");
liste_methodes.push_back("gww-adapt");
}



void arguments_methode(char** argv, int& narg, int& graine1, int& nbessais, string& method, list<string>& methodes_possibles)
{  graine1= argument2ul (argv[narg+1], " graine du gnrateur alatoire de la mthode ");
  nbessais = argument2ul (argv[narg+2], " nombre d'essais ");
  method = argument2lp (argv[narg+3], "methode non implantee ", methodes_possibles);

  narg=narg+3;
  *ofile << " graine tirage alatoire " << graine1 
	 << " nb essais " << nbessais << " mthode " << method << endl;
}

void arguments_tracemode(char** argv, int& narg)
{ TRACEMODE = argument2ul (argv[narg+1], "indicateur trace ");
 *ofile << " mode trace " << TRACEMODE << endl; 
 narg++;}


void arguments_algorithme(char** argv, int& narg, int& nbmouv)
{nbmouv= argument2ul (argv[narg+1], "longueur marche ");
 *ofile << " longueur marche " << nbmouv << endl;
 narg=narg+1;
}


void arguments_metropolis(char**argv, int& narg, double&  temp)
{ temp = argument2d (argv[narg+1], " temperature " );
 *ofile << " temperature " << temp;
 narg=narg+1;
}

void arguments_voisinage(char** argv,int& narg, int& taille_voisinage_min, int& taille_voisinage_max, int & fin_voisinage, int& var_conflit, int& val_conflit)

{       
    string variables_en_conflit = argv[narg+1];

    if (variables_en_conflit == "cv") 
      var_conflit=1;

    else var_conflit=0;

    string minimum_conflit = argv[narg+2];      
    if (minimum_conflit== "mc")
      val_conflit=1;
    else val_conflit=0;
    taille_voisinage_min= argument2ul (argv[narg+3], " nombre minimum de voisins ");
    taille_voisinage_max= argument2ul (argv[narg+4], "nombre maximum de voisins ");
    fin_voisinage=argument2bul(argv[narg+5],"indicateur epuisement voisinage",0,2);
    *ofile << " variables en conflit " << variables_en_conflit << " " << var_conflit;
    *ofile << " minimum conflit " << minimum_conflit << " " << val_conflit;
    *ofile << " min voisins " << taille_voisinage_min ;
    *ofile << " max_voisins " << taille_voisinage_max;
    *ofile << " epuisement voisinage " << fin_voisinage << endl;
    narg= narg+5;
}

void arguments_tabu(char** argv,int & narg, int& longtabu)
{longtabu = argument2ul(argv[narg+1]," longueur liste taboue ");
 *ofile << " longueur liste taboue " << longtabu;
 narg= narg+1;
}

void arguments_recuit(char** argv,int & narg, double& inittemp)
{inittemp = argument2d(argv[narg+1]," temperature initiale ");
 *ofile << " temperature initiale " << inittemp;
 narg= narg+1;
}

void arguments_marcheseuil(char** argv,int & narg, int& seuildebut)
{seuildebut = argument2ul (argv[narg+1]," seuil debut  " );
 *ofile << " seuil debut  " << seuildebut;
 narg= narg+1;
}

void arguments_gww(char** argv, int & narg, int& taille, int& test_regroupement,
		   int & derniermouv, int & elitisme, int& stop)
{taille = argument2ul (argv[narg+1]," nombre particules " );
 test_regroupement = argument2bul (argv[narg+2]," test regroupement ",0,1 );
 derniermouv = argument2bul (argv[narg+3]," baisse dernier mouvement ",0,1 );
 elitisme= argument2bul (argv[narg+4], " indicateur elitisme ",0,1);
 stop = argument2bul (argv[narg+5], " indicateur arret stagnation ",0,1);
 *ofile << " nombre particules " << taille ;
 *ofile << " test regroupement " << test_regroupement;
 *ofile << " baisse dernier mouvement " << derniermouv;
 *ofile << " elitisme " << elitisme;
 *ofile << " arret stagnation " << stop;
narg=narg+5;}

void arguments_gww_marche(char** argv, int& narg, string& walk_method, list<string>& liste_methodes)
{
 walk_method = argument2lp (argv[narg+1], " methode marche non implante " , liste_methodes);
*ofile << " methode marche " << walk_method << endl;
narg=narg+1;
}


void arguments_gww_standard(char** argv, int & narg, double& descenteseuil, int& seuilmin)
{descenteseuil= argument2bd(argv[narg+1]," facteur descente seuil ", 0, 1 );
seuilmin=argument2ul (argv[narg+2]," borne inferieure ") ;
 *ofile << " facteur descente seuil " << descenteseuil;
 *ofile << " borne-infrieure " << seuilmin;
 narg=narg+2;
}

void arguments_gww_descente_rapide(char** argv, int & narg, int & nb_tues, int & nb_tues_max, double& descenteseuil)
{nb_tues= argument2ul (argv[narg+1] ," nb tus " );
nb_tues_max=argument2ul (argv[narg+2]," nb tus max ");
 descenteseuil= argument2bd (argv[narg+3]," facteur descente seuil ", 0, 1 );
*ofile << " nb tus " << nb_tues;
 *ofile << " nb tues max " << nb_tues_max;
 *ofile << " facteur descente seuil " << descenteseuil;
 narg=narg+3;
}


void arguments_gww_distance_median(char** argv, int & narg,  double& distance_median)
{ distance_median= argument2bd (argv[narg+1], " facteur distance median ",0, 1);
 *ofile << " facteur distance median " << distance_median;
 narg=narg+1;
}

void arguments_gww_distance_meilleur(char** argv, int & narg, double& distance_meilleur)
{
 distance_meilleur= argument2bd (argv[narg+1]," facteur distance meilleur " ,0,1);
 *ofile << " facteur distance meilleur " << distance_meilleur;
 narg=narg+1;
}



void arguments_gww_adaptatif(char** argv, int& narg, int & nb_tues)
{nb_tues = argument2ul (argv[narg+1]," nb tus "  );
*ofile << " nb tus " << nb_tues;
narg++;
}

void arguments_gww_sans_seuil (char** argv, int & narg, int & nb_tues, int& nb_iter)
{nb_tues =  argument2ul (argv[narg+1]," nb tus " );
 nb_iter=   argument2ul (argv[narg+2]," nb iterations "  );
*ofile << " nb tus " << nb_tues;
*ofile << " nb iterations " << nb_iter;
 narg= narg+2;
}

void arguments_taburate(char** argv, int & narg, float & Pd, float & P0, int & longtabu) {
  Pd = argument2bd (argv[narg+2], " Pd ",0,1);
  P0 = argument2bd (argv[narg+3], " P0 ",0,1);
  longtabu = argument2ul(argv[narg+4], " longueur liste taboue ");
  *ofile << " Pd = " << Pd << endl;
  *ofile << " P0 =  " << P0 << endl;
  *ofile << " longueur liste taboue = " << longtabu << endl;
  narg= narg+3;
}



/*-----------------------------------------CREATION DES OBJETS ALGORITHMES----------------------------*/
// lecture des parametres de la marche et creation de l'objet LSAlgorithm 

LSAlgorithm* algo_marche (char** argv,int& narg,string& method)
		
{LSAlgorithm* algo;
 Metaheuristic* mheuristic = new Metaheuristic();
 NeighborhoodSearch* nbhsear;
  int taille_voisinage_min, taille_voisinage_max, fin_voisinage,var_conflit,val_conflit,seuildebut;
  double temp=0;
  int longtabu=0;
  int nbmouv;
  double inittemp;
  float Pd, P0; 
  arguments_algorithme(argv,narg,nbmouv);
  if (method == "metropolis")
    arguments_metropolis(argv,narg,temp);
  else if(method == "tabu")
    arguments_tabu(argv,narg,longtabu);
  else if(method == "simann")
    arguments_recuit(argv,narg,inittemp);
  else if (method == "threshold")
    arguments_marcheseuil(argv,narg,seuildebut);
  else if (method == "taburate" )
    arguments_taburate(argv, narg,  Pd, P0, longtabu);
  arguments_voisinage(argv,narg,taille_voisinage_min,taille_voisinage_max,fin_voisinage,var_conflit,val_conflit);
  algo = new LSAlgorithm (nbmouv);
  nbhsear = new NeighborhoodSearch (taille_voisinage_min,taille_voisinage_max,fin_voisinage,var_conflit,val_conflit);
  algo->nbhsearch=nbhsear;
 if (method == "metropolis")
   mheuristic = new Metropolis(temp);
 else if (method == "tabu")
   mheuristic = new TabuSearch (longtabu);
 else if (method == "simann")
   mheuristic = new SimulatedAnnealing (inittemp,nbmouv);
 else if (method == "threshold")
   mheuristic = new ThresholdAccepting(seuildebut,nbmouv);
 else if ((method == "descente") || (method == "greedy"))
   mheuristic = new GreedySearch ();
 else if (method == "random")
   mheuristic= new RandomSearch ();
 else if (method == "taburate") 
   mheuristic = new TabuAcceptingrate (longtabu, Pd, P0);
 algo->mheur = mheuristic;
 return algo; 
}

// lecture des parametres GWW et creation de l'objet GWWAlgorithm

GWWAlgorithm* algo_gww(char** argv, int& narg, string& method , int& taille, list<string>& liste_methodes)
{GWWAlgorithm* algogww = new GWWAlgorithm();
 int testregroupement, nb_tues, nb_tues_max, nb_iter, derniermouv,elitisme, stop;
 double descenteseuil, distance_median, distance_meilleur;
 int seuilmin;
 string walk_method;
 arguments_gww(argv,narg,  taille, testregroupement, derniermouv,elitisme, stop);
 if (method == "gww-nothreshold")
   {arguments_gww_sans_seuil (argv, narg,  nb_tues, nb_iter);
   algogww = new NothresholdGWWAlgorithm 
     (taille,testregroupement, derniermouv,elitisme, stop, nb_tues,nb_iter);}
 else if (method == "gww")
   {arguments_gww_standard (argv, narg, descenteseuil, seuilmin);
   algogww = new StandardGWWAlgorithm 
     (taille,testregroupement, derniermouv,elitisme, stop, descenteseuil, seuilmin);
   }
 else if (method == "gww-killworst")
   {arguments_gww_standard (argv, narg, descenteseuil, seuilmin);
   algogww = new FastStandardGWWAlgorithm 
     (taille,testregroupement, derniermouv,elitisme, stop, descenteseuil, seuilmin);
   }

 else if (method == "gww-adapt")
   {arguments_gww_adaptatif (argv, narg, nb_tues);
   algogww = new AdaptiveGWWAlgorithm (taille, testregroupement, derniermouv,elitisme,stop, nb_tues);
   }
 else if (method == "gww-adaptkillworst")
   {arguments_gww_descente_rapide (argv, narg, nb_tues, nb_tues_max, descenteseuil);
   algogww = new FastAdaptGWWAlgorithm (taille, testregroupement, derniermouv, elitisme, stop, nb_tues, nb_tues_max, descenteseuil);}
 else if (method == "gww-mediandist")
   {arguments_gww_distance_median (argv, narg, distance_median);
   algogww = new MedianAdaptGWWAlgorithm (taille, testregroupement, derniermouv, elitisme, stop, distance_median);}
 else if (method == "gww-bestdist")
   {arguments_gww_distance_meilleur (argv, narg, distance_meilleur);
   algogww = new BestAdaptGWWAlgorithm (taille, testregroupement, derniermouv, elitisme,  stop, distance_meilleur);
   }


 arguments_gww_marche(argv,narg,walk_method,liste_methodes);
 algogww->walkalgorithm= algo_marche (argv,narg,walk_method);
 algogww->walkalgorithm->methodname=method; // bizarrerie a modifier (utilisee pour la trace)
 return algogww;
}


// lecture de l'argument method et appel selon l'argument de la cration d'un des  2 principaux types d'algo (LS et GWW)
IncompleteAlgorithm* algo_creation(char** argv, int& narg, int& taille, int& graine1, int & nbessais)
 { IncompleteAlgorithm* algo = new IncompleteAlgorithm();
  list<string> liste_methodes;
  string method;
  definir_liste_methodes(liste_methodes);
  arguments_methode(argv,narg,graine1,nbessais,method,liste_methodes);

 if(method == "metropolis" || method == "tabu" || method =="descente" || method =="greedy" || method =="random" || method =="threshold" || method =="simann")
   {algo = algo_marche (argv,narg,method);
   taille=1;   
   }
 else if (method == "gww" || method =="gww-killworst"|| method == "gww-nothreshold" || method == "gww-adapt" || method == "gww-adaptkillworst"
	  || method == "gww-mediandist" || method == "gww-bestdist")
   algo= algo_gww (argv,narg,method,taille,liste_methodes);	
 algo->methodname=method;
 return algo;
 }


//********************************** les utilitaires***********************************************

/* la plus mauvaise valeur de la population */
int valeur_max(Configuration** population, int taille)
{return population[0]->valuation;
}

/* la meilleure valeur de la population */
int valeur_min(Configuration** population, int taille)
{ return population[taille-1]->valuation; 
}

/* la valeur mediane de la population */
int valeur_mediane(Configuration** population, int taille)
{ return population[taille/2]->valuation; 
}

// le comparateur pour le tri de la population 
static int comparepopulation(const void* e1,const void* e2)
{  return ((*(Configuration**) e1)->valuation < (*(Configuration**)e2)->valuation);}

// le tri de la population dans le sens du pire au meilleur
void populationsort(Configuration** population, int taille)
{  qsort(population,taille,sizeof(Configuration*),comparepopulation);}




/* ------------------------------ECRITURES--------------------------------------------------*/


/* le nom du fichier de sortie : pour les tests : resultatsxxx/concatnation des arguments */
void ofile_name (char* filename, int argc, char** argv)
{ 
  sprintf(filename,"%s%s","resultats101/",argv[2]);
  for (int i=3;i<argc;i++)
    sprintf(filename,"%s-%s",filename,argv[i]);
  cout << filename << endl;
}


/* les ecritures sur le fichier de sortie *ofile */



void ecriture_graine(int graine, int nessai)
{*ofile << " essai n. " << nessai << " graine " << graine << endl;}

void ecriture_fin_resolution(int meilleur)
{*ofile<< "meilleure valeur --------->  " <<  meilleur << endl;}

void ecriture_debut_resolution(int pire, int meilleur,string& method)
{*ofile<< "configuration initiale : " << " pire valeur  " << pire 
       << " meilleure valeur " << meilleur << endl ;
}


void ecriture_stat_essai()
{
  *ofile<<  " Temps essai: " << Statistiques->execution_time_try[Statistiques->current_try]
                             << endl;
}


void ecriture_stat_probleme() {	
  // role : criture des stats pour le probleme courant avec les essais de 0  current_try-1
  int current_problem;
  int nbessais;
  float temps_essais_moyen;
  float nombre_chgseuil_moyen;

  current_problem = Statistiques->current_pb;
  nbessais = Statistiques->current_try;

  *ofile << "=========================================================================="<< endl;

  if (nbessais == 0) {
    *ofile << " Interruption !! " << endl;
  }
  else {
    
    *ofile << " " << Statistiques->trouve[current_problem] << " essais avec solutions sur " 
	   <<  nbessais  << " essais. " << endl;

    double somme=0; int meilleur=RAND_MAX; int pire=0; double ecart=0; double moyenne;

    for(int i=0; i < nbessais; i++) { 
      somme += Statistiques->cost_try [i];
      if (Statistiques->cost_try[i] < meilleur) meilleur = Statistiques->cost_try[i];
      if (Statistiques->cost_try[i] > pire) pire = Statistiques->cost_try[i];
    }
    moyenne = somme / nbessais ;

    for(int i=0; i < nbessais ;i++) { 
      ecart += pow(Statistiques->cost_try [i] - moyenne,2);
    }
    ecart=sqrt(ecart/nbessais);

    temps_essais_moyen = 0.0;
    for(int i=0; i < nbessais; i++) { 
      temps_essais_moyen += Statistiques->execution_time_try[i];
    }
    temps_essais_moyen = temps_essais_moyen / nbessais ;
    nombre_chgseuil_moyen = Statistiques->thresholdchanges/nbessais;    

    *ofile   << " Meilleur essai : "    << meilleur      << endl;
    *ofile   << " Plus mauvais : "      << pire          << endl ;
    * ofile  << " Moyenne : "           << moyenne       << endl;
    * ofile  << " Ecart type : "        << ecart         << endl;
    *ofile   << " Temps essai moyen: "  << temps_essais_moyen << endl;
    *ofile   << " Nb changements seuil moyen : " << nombre_chgseuil_moyen << endl;
    *ofile   << "=========================================================================="
	     << endl << endl;
  }
}



void ecriture_changement_seuil (int seuil, int delta, int meilleur, int pire,int mediane, int nbessaisvoisins, int nb_au_seuil)
{
  *ofile << " --- seuil " << seuil << " delta " << delta
	 << " meilleur " << meilleur
	 << " pire " << pire
	 << " mediane " << mediane 
	 << " au seuil " << nb_au_seuil
    	 << " voisins tests " << nbessaisvoisins
         << endl;
}

void ecriture_nb_tues(int nb_tues)
{*ofile << " nombre particules redistribues " << nb_tues << endl;}


void ecriture_fin_gww( int nb_chang_seuil, int nb_mouv)
{  *ofile << " Fin GWW  : nombre de changements de seuil : " << nb_chang_seuil << endl;
   *ofile << " nombre total de mouvements : " << nb_mouv << endl;}



void ecriture_meilleure_valeur (string & method, int valeur, int seuil, int nbmouv)
{
*ofile << " meilleure valeur " << valeur ;
  if (method == "gww" || method == "gww-killworst" || method == "gww-adapt" || method == "gww-adaptkillworst" || method == "gww-mediandist" 
|| method == "gww-bestdist")    *ofile << " valeur seuil " << seuil ;
  else  if (method == "gww-nothreshold") 
    *ofile   << " iteration "  << nbmouv;
  else *ofile <<" nb mouvements " << nbmouv;
  *ofile       <<  " temps " <<  Statistiques->execution_time_try [Statistiques->current_try]
               << endl;   
}


void ecriture_statistiques_global () {

  int pbsol;      // le nombre de problemes avec au moins un essai russi
  int npb;        // le nombre de problemes etudis
  int nb_succes;  // le nombre d'essais russis sur tous les problemes

  npb = Statistiques->current_pb + 1;

  pbsol=0;
  for (int t=0 ; t < npb ; t++) {
    if (Statistiques->trouve[t] >=1) 
      pbsol++;
  }
  *ofile <<"==========================================================================" << endl;
  *ofile << pbsol << " problemes avec solution(s) sur " << npb << " problemes " << endl;

  *ofile << " Succes par probleme : | " ;
  for (int i=0 ; i < npb ; i++) {
    *ofile<< Statistiques->trouve[i] << " | " ; 
  }
  *ofile << endl;

  nb_succes=0;
  for (int i=0 ; i < npb ; i++) {
    nb_succes += Statistiques->trouve[i];
  }
  *ofile<< " Nb succes " << nb_succes << " sur " 
	<< (npb-1) * Statistiques->max_tries +  Statistiques->current_try // nb d'essais achevs
	<< " essais " << endl;

  if (nb_succes > 0) {
    *ofile << " temps moyen pour un succes " 
	   << Statistiques->total_execution_time / nb_succes << endl;
  }

  *ofile << " Temps total : " << Statistiques->total_execution_time << endl; 
  *ofile <<"==========================================================================" <<endl; 
}


void ecriture_fin_lsrun(double avgnhtries, double avgsqnhtries)
{*ofile << " nb moyen d'essais par mouvement " << avgnhtries 
	<< "  ecart type " << sqrt ( avgsqnhtries - avgnhtries * avgnhtries) << endl;
}


/* --------------------------LANCEMENT D'UN ESSAI -------------------------------------------*/


// instanciation aleatoire
void instanciation_aleatoire(OpProblem* problem, Configuration** population, int taille)
{for (int i=0;i<taille;i++)
  problem->random_configuration(population[i]);
}


// evaluation de la population
void calcul_valeur_population(OpProblem* problem, Configuration** population,int taille)
{for (int i=0;i<taille;i++)
  population[i]->valuation = problem->config_evaluation(population[i]);
}

// execution d'un essai d'un algo sur un  probleme
void executer_essai
   (OpProblem* problem,IncompleteAlgorithm* algo, Configuration** population, int taille, int graine1, int nessai)
  {
    // graine du gnrateur aleatoire pour l'essai
    srand48(graine1+nessai);
    ecriture_graine(graine1+nessai,nessai);

    Statistiques->execution_time_try[nessai]=0;
    Statistiques->current_try=nessai;            
    // dclenchement du chronomtre
    start_timers(); 
    // population initiale 

    instanciation_aleatoire(problem,population,taille);
    *ofile << " population instanciee " << endl;
    // evaluation de la population
    calcul_valeur_population(problem,population,taille);
    *ofile << " population evaluee " << endl;
    // tri de la population
    populationsort(population,taille);
    // stockage du meilleur dans best_config
    problem->best_config->copy_element(population[taille-1]); 
    // pour les algos de type gww avec seuil , le seuil est initialis au pire de la population, sinon  RANDMAX
    algo->initthreshold(population,taille); 
    
    Statistiques->cost_try[nessai]=valeur_min (population,taille);  
    ecriture_debut_resolution(valeur_max(population,taille),valeur_min(population,taille),algo->methodname);
    
    // lancement de la resolution 
    algo->run(problem,population);
    // apres resolution : arret du chronometre
    stop_timers(VIRTUAL);
    ecriture_fin_resolution(Statistiques->cost_try[nessai]);
    problem->best_config_analysis(); 
    //    problem->best_config_write();
    // verification de best_config en recalculant sa valeur 
    problem->best_config_verification();
    Statistiques->execution_report(nessai,problem->lower_bound);
}






