


#include <cerrno>
#include <stdio.h>
#include <list>
#include <vector>
#include <string>
#include <algorithm>
#include <fstream.h>
#include "timer.h"
#include "incop.h"
#include "incoputil.h"
#include "csproblem.h"
#include "color.h"
#include "maxclique.h"


#include <math.h>
#include <unistd.h>


extern ofstream* ofile;  // le fichier de sortie

extern Stat_GWW * Statistiques; 






void arguments_clique(char** argv, int& narg, int & clsize)
{ 
  clsize = argument2ul(argv[narg+1],"taille clique ");
  *ofile << " maxclique  " << argv[narg+1] << "  taille clique " << clsize << endl;
  narg++;
}


int main (int argc, char** argv) {

  // les divers arguments lus dans la ligne de commande

  int clsize,taille,nbessais;
  int graine1;
  int narg = 1;  // compteur des arguments

  // le nom du fichier de sortie : pour les tests : version logiciel + concatnation des arguments
  char filename [1000];
  if ((string)argv[1] == "arg")
    ofile_name(filename, argc, argv);
  else sprintf(filename,"%s",argv[1]);

  ofstream ofile1 (filename);
  ofile = & ofile1;

  ifstream file (argv[1]); // le fichier de donnes 

  // lecture des arguments du problme
  arguments_clique(argv,narg,clsize);

  // lecture des paramtres de l'algo et cration de l'objet algo
  IncompleteAlgorithm* algo = algo_creation (argv, narg, taille, graine1, nbessais);

  // allocation de l'objet pour les stats
  Statistiques=new Stat_GWW (1, nbessais);
  
  // argument pour la trace
  arguments_tracemode(argv,narg);
  // pour la rcupration du signal 10
  sigaction();

  // creation du probleme (lecture des donnes, cration des structures de donnes et du problme)
  CliqueProblem* problem = clique_problem_creation (clsize,file);

  // creation de la population et initialisation 
  // La population : tableau de configurations
  Configuration* population[taille];
  problem->init_population(population,taille);
  problem->allocate_moves();

  // initialisation des statistiques
  Statistiques->init_pb(0);

  // boucle sur les essais 

  for(int nessai = 0;nessai< nbessais ; nessai++)
    executer_essai (problem,algo,population,taille,graine1,nessai);

  // ecriture statistiques 
  Statistiques->current_try++; 
  ecriture_stat_probleme();
  delete problem;
  cout << "Fin rsolution " << Statistiques->total_execution_time << endl;
  return 0;
  
  
}



